# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from crossing_detector/DetectCrossingRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import lama_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class DetectCrossingRequest(genpy.Message):
  _md5sum = "47c7b7fc5844889cf8c17ff68744a706"
  _type = "crossing_detector/DetectCrossingRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """lama_msgs/PlaceProfile profile
float32 frontier_width
float32 max_frontier_angle
float32 min_relevance

================================================================================
MSG: lama_msgs/PlaceProfile
# 2D Description of a place by some points at obstacle borders
# The difference with a LaserScan is that some segments can
# be marked as to be excluded. Such segments will be the segments
# where the range is the maximum range of the LaserSCan or
# borders between free and unknown pixels of a costmap.

Header header

geometry_msgs/Polygon polygon

# Segments to exclude, segment i is between point i and i+1.
# The last segment is between points (n-1) and 0, where n is the number of points.
int32[] exclude_segments

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Polygon
#A specification of a polygon where the first and last points are assumed to be connected
Point32[] points

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z"""
  __slots__ = ['profile','frontier_width','max_frontier_angle','min_relevance']
  _slot_types = ['lama_msgs/PlaceProfile','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       profile,frontier_width,max_frontier_angle,min_relevance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DetectCrossingRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.profile is None:
        self.profile = lama_msgs.msg.PlaceProfile()
      if self.frontier_width is None:
        self.frontier_width = 0.
      if self.max_frontier_angle is None:
        self.max_frontier_angle = 0.
      if self.min_relevance is None:
        self.min_relevance = 0.
    else:
      self.profile = lama_msgs.msg.PlaceProfile()
      self.frontier_width = 0.
      self.max_frontier_angle = 0.
      self.min_relevance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.profile.header.seq, _x.profile.header.stamp.secs, _x.profile.header.stamp.nsecs))
      _x = self.profile.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.profile.polygon.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.profile.polygon.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.profile.exclude_segments)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.profile.exclude_segments))
      _x = self
      buff.write(_struct_3f.pack(_x.frontier_width, _x.max_frontier_angle, _x.min_relevance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.profile is None:
        self.profile = lama_msgs.msg.PlaceProfile()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.profile.header.seq, _x.profile.header.stamp.secs, _x.profile.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.profile.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.profile.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.profile.polygon.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.profile.polygon.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.profile.exclude_segments = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.frontier_width, _x.max_frontier_angle, _x.min_relevance,) = _struct_3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.profile.header.seq, _x.profile.header.stamp.secs, _x.profile.header.stamp.nsecs))
      _x = self.profile.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.profile.polygon.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.profile.polygon.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.profile.exclude_segments)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.profile.exclude_segments.tostring())
      _x = self
      buff.write(_struct_3f.pack(_x.frontier_width, _x.max_frontier_angle, _x.min_relevance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.profile is None:
        self.profile = lama_msgs.msg.PlaceProfile()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.profile.header.seq, _x.profile.header.stamp.secs, _x.profile.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.profile.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.profile.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.profile.polygon.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.profile.polygon.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.profile.exclude_segments = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      _x = self
      start = end
      end += 12
      (_x.frontier_width, _x.max_frontier_angle, _x.min_relevance,) = _struct_3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_3f = struct.Struct("<3f")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from crossing_detector/DetectCrossingResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import lama_msgs.msg
import geometry_msgs.msg

class DetectCrossingResponse(genpy.Message):
  _md5sum = "f5dac4d3b64fd3bf2c934befc3a0bb59"
  _type = "crossing_detector/DetectCrossingResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """lama_msgs/Crossing crossing


================================================================================
MSG: lama_msgs/Crossing
# The main aim of a crossing is to store frontier information.

# Crossing center.
geometry_msgs/Point center

# Crossing radius.
float32 radius

# Max. range of the data used to compute the crossing.
float32 max_range

Frontier[] frontiers

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: lama_msgs/Frontier
# Frontier is a line segment through which a robot can go.

# First point
geometry_msgs/Point p1

# Second point, so that angle(r-p1, r-p2) is positive, where r is crossing center.
geometry_msgs/Point p2

# Segment length, i.e. width of free space
float32 width

# Angle between x-axis and line between origin and frontier middle. Where x-axis
# and origin refer to the data from which the frontier is computed, in general a LaserScan.
float32 angle
"""
  __slots__ = ['crossing']
  _slot_types = ['lama_msgs/Crossing']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       crossing

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DetectCrossingResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.crossing is None:
        self.crossing = lama_msgs.msg.Crossing()
    else:
      self.crossing = lama_msgs.msg.Crossing()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3d2f.pack(_x.crossing.center.x, _x.crossing.center.y, _x.crossing.center.z, _x.crossing.radius, _x.crossing.max_range))
      length = len(self.crossing.frontiers)
      buff.write(_struct_I.pack(length))
      for val1 in self.crossing.frontiers:
        _v1 = val1.p1
        _x = _v1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v2 = val1.p2
        _x = _v2
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_2f.pack(_x.width, _x.angle))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.crossing is None:
        self.crossing = lama_msgs.msg.Crossing()
      end = 0
      _x = self
      start = end
      end += 32
      (_x.crossing.center.x, _x.crossing.center.y, _x.crossing.center.z, _x.crossing.radius, _x.crossing.max_range,) = _struct_3d2f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.crossing.frontiers = []
      for i in range(0, length):
        val1 = lama_msgs.msg.Frontier()
        _v3 = val1.p1
        _x = _v3
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v4 = val1.p2
        _x = _v4
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.width, _x.angle,) = _struct_2f.unpack(str[start:end])
        self.crossing.frontiers.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3d2f.pack(_x.crossing.center.x, _x.crossing.center.y, _x.crossing.center.z, _x.crossing.radius, _x.crossing.max_range))
      length = len(self.crossing.frontiers)
      buff.write(_struct_I.pack(length))
      for val1 in self.crossing.frontiers:
        _v5 = val1.p1
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = val1.p2
        _x = _v6
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_2f.pack(_x.width, _x.angle))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.crossing is None:
        self.crossing = lama_msgs.msg.Crossing()
      end = 0
      _x = self
      start = end
      end += 32
      (_x.crossing.center.x, _x.crossing.center.y, _x.crossing.center.z, _x.crossing.radius, _x.crossing.max_range,) = _struct_3d2f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.crossing.frontiers = []
      for i in range(0, length):
        val1 = lama_msgs.msg.Frontier()
        _v7 = val1.p1
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v8 = val1.p2
        _x = _v8
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.width, _x.angle,) = _struct_2f.unpack(str[start:end])
        self.crossing.frontiers.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2f = struct.Struct("<2f")
_struct_3d2f = struct.Struct("<3d2f")
_struct_3d = struct.Struct("<3d")
class DetectCrossing(object):
  _type          = 'crossing_detector/DetectCrossing'
  _md5sum = '4c81e37b13004977ae7e6c53cee6c96a'
  _request_class  = DetectCrossingRequest
  _response_class = DetectCrossingResponse
